//+------------------------------------------------------------------+
//|                                            ROC-EURUSDJPYGNBP.mq4 |
//|                               Copyright  2008, PHIL trader24    |
//|                                            http://www.lareva.com |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 DeepSkyBlue
#property indicator_color2 DarkOrange
#property indicator_color3 Red
#property indicator_color4 White
#property indicator_color5 Green


//---- Paramtres
extern int Periode=14;


int TotalDevise=5;

//---- buffers
double BufferEUR[];
double BufferUSD[];
double BufferJPY[];
double BufferGBP[];
double BufferCHF[];


//+------------------------------------------------------------------+
//| Initialisation                                                   |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);

   string short_name;
   short_name="ROC-";
   IndicatorShortName(short_name);
   IndicatorDigits(0);
  
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufferEUR);
   SetIndexDrawBegin(0,0);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,BufferUSD);
   SetIndexDrawBegin(1,0);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,BufferJPY);
   SetIndexDrawBegin(2,0);

   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,BufferGBP);
   SetIndexDrawBegin(3,0);
   
      SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,BufferCHF);
   SetIndexDrawBegin(4,0);

   SetLevelStyle(STYLE_SOLID,1,Silver);
   SetLevelValue(0,0);
   
   return(0);
  }
  
int deinit()
  {
  if (ObjectFind("EUR")>=0)
     ObjectDelete("EUR");
  return(0);
  }
//+------------------------------------------------------------------+
//|  Main fonction                                                   |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i,counted_bars=IndicatorCounted();
   double Total;
   int mEURUSD;
   int mEURJPY;
   int mUSDJPY;
   int mGBPUSD;
   int mEURGBP;
   int mGBPJPY;
   int mGBPCHF;
   int mCHFJPY;
   int mEURCHF;
   int mUSDCHF;
   
   int TotalWindow=WindowsTotal();

  if (ObjectFind("EUR")<0)
     {
     ObjectCreate("EUR",OBJ_LABEL,TotalWindow-1,0,0);
     ObjectSet("EUR",OBJPROP_XDISTANCE,150);
     ObjectSet("EUR",OBJPROP_YDISTANCE,1);
     ObjectSetText("EUR","EUR",12,"Arial",indicator_color1);
     }
  if (ObjectFind("USD")<0)
     {
     ObjectCreate("USD",OBJ_LABEL,TotalWindow-1,0,0);
     ObjectSet("USD",OBJPROP_XDISTANCE,200);
     ObjectSet("USD",OBJPROP_YDISTANCE,1);
     ObjectSetText("USD","USD",12,"Arial",indicator_color2);
     }
  if (ObjectFind("JPY")<0)
     {
     ObjectCreate("JPY",OBJ_LABEL,TotalWindow-1,0,0);
     ObjectSet("JPY",OBJPROP_XDISTANCE,250);
     ObjectSet("JPY",OBJPROP_YDISTANCE,1);
     ObjectSetText("JPY","JPY",12,"Arial",indicator_color3);
     }
  if (ObjectFind("GBP")<0)
     {
     ObjectCreate("GBP",OBJ_LABEL,TotalWindow-1,0,0);
     ObjectSet("GBP",OBJPROP_XDISTANCE,300);
     ObjectSet("GBP",OBJPROP_YDISTANCE,1);
     ObjectSetText("GBP","GBP",12,"Arial",indicator_color4);
     }
     if (ObjectFind("CHF")<0)
     {
     ObjectCreate("CHF",OBJ_LABEL,TotalWindow-1,0,0);
     ObjectSet("CHF",OBJPROP_XDISTANCE,350);
     ObjectSet("CHF",OBJPROP_YDISTANCE,1);
     ObjectSetText("CHF","CHF",12,"Arial",indicator_color5);
     }


   if(Bars<=Periode+1) return(0);
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
	
	if(counted_bars == 0) limit = Bars;
	if(counted_bars > 0)	 limit = Bars - counted_bars;
	
   
	for(i = limit; i >= 0; i--)
     {
     
     mEURUSD= NormalizeDouble((iClose("EURUSD",0,i)-iClose("EURUSD",0,i+Periode))/0.0001,0);  
     mEURJPY= NormalizeDouble((iClose("EURJPY",0,i)-iClose("EURJPY",0,i+Periode))/0.01,0);  
     mUSDJPY= NormalizeDouble((iClose("USDJPY",0,i)-iClose("USDJPY",0,i+Periode))/0.01,0);  
     mCHFJPY= NormalizeDouble((iClose("USDJPY",0,i)-iClose("USDJPY",0,i+Periode))/0.01,0);
      mUSDCHF= NormalizeDouble((iClose("USDCHF",0,i)-iClose("USDCHF",0,i+Periode))/0.0001,0); 
     
     mGBPJPY= NormalizeDouble((iClose("GBPJPY",0,i)-iClose("GBPJPY",0,i+Periode))/0.01,0);  
     mEURGBP= NormalizeDouble((iClose("EURGBP",0,i)-iClose("EURGBP",0,i+Periode))/0.0001,0);  
     mGBPUSD= NormalizeDouble((iClose("GBPUSD",0,i)-iClose("GBPUSD",0,i+Periode))/0.0001,0);
     mGBPCHF= NormalizeDouble((iClose("GBPCHF",0,i)-iClose("GBPCHF",0,i+Periode))/0.0001,0); 
      mEURCHF= NormalizeDouble((iClose("EURCHF",0,i)-iClose("EURCHF",0,i+Periode))/0.0001,0); 
    
     BufferEUR[i]=(BufferEUR[i+1]+BufferEUR[i+2]+((mEURUSD+mEURJPY+mEURGBP+mEURCHF)/(TotalDevise-1)))/4;
     BufferUSD[i]=(BufferUSD[i+1]+BufferUSD[i+2]+((mUSDJPY-mEURUSD-mGBPUSD+mUSDCHF)/(TotalDevise-1)))/4;
     BufferJPY[i]=(BufferJPY[i+1]+BufferJPY[i+2]+((mEURJPY-mUSDJPY-mGBPJPY-mUSDJPY)/(TotalDevise-1)))/4;  
     BufferGBP[i]=(BufferGBP[i+1]+BufferGBP[i+2]+((mEURGBP+mGBPJPY+mGBPUSD+mGBPCHF)/(TotalDevise-1)))/4;
     BufferCHF[i]=(BufferCHF[i+1]+BufferCHF[i+2]+((mCHFJPY-mGBPCHF-mUSDCHF-mEURCHF)/(TotalDevise-1)))/4;
     
     }
   return(0);
  }
//+------------------------------------------------------------------+